/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.StatusDao;
import com.portofolio.dto.StatusDto;
import com.portofolio.entity.Status;
import com.portofolio.entity.vo.StatusId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;

@Lazy
@Service
public class StatusService extends BaseServiceImpl {

	@Lazy
	@Autowired
	StatusDao statusDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;

	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(StatusDto statusDto) {
		result.clear();
		Integer kdStatus = getIdTerahir(Status.class.getSimpleName());
		StatusId statusId=new StatusId();
		statusId.setKdProfile(getKdProfile());
		statusId.setKdStatus(kdStatus);
		Status status = CommonUtil.findOne(statusDao, statusId);
		if (CommonUtil.isNullOrEmpty(status)) {
			status = new Status();
			status.setKdDepartemen(getSession().getKdDepartemen());
			status.setNoRec(generateUuid32());
			status.setVersion(1);
			status.setId(statusId);
			BeanUtils.copyProperties(statusDto, status);
			status = statusDao.save(status);
			result.put("objekStatus", status);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("status.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(StatusDto statusDto, Integer kdStatus, Integer version) {
		result.clear();
		StatusId statusId=new StatusId();
		statusId.setKdProfile(getKdProfile());
		statusId.setKdStatus(kdStatus);
		Status status = CommonUtil.findOne(statusDao, statusId);
		if (CommonUtil.isNotNullOrEmpty(status)) {
			if (version < status.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(statusDto, status);
			status = statusDao.save(status);
			result.put("objekStatus", status);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	@Transactional
	public Map<String, Object> delete(Integer kdStatus, Integer version) {
		result.clear();
		StatusId statusId=new StatusId();
		statusId.setKdProfile(getKdProfile());
		statusId.setKdStatus(kdStatus);
		Status status = CommonUtil.findOne(statusDao, statusId);
		if (CommonUtil.isNotNullOrEmpty(status)) {
			if (version < status.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			status.setStatusEnabled(false);
			status = statusDao.save(status);
			result.put("objekStatus", status);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	public Map<String, Object> grid(String sort, String dir, String namaStatus) {
		result.clear();
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<Status> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaStatus)) {
			list = statusDao.findAllList(getKdProfile(),pageReq);
			result = createTree(list);
		} else {
			list = statusDao.findAllList(getKdProfile(),namaStatus, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}
	
	
	public Map<String, Object> combo(String sort, String dir, String namaStatus) {
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<Status> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaStatus)) {
			list = statusDao.findAllListCombo(getKdProfile(),pageReq);
			result = createTree(list);
		} else {
			list = statusDao.findAllListCombo(getKdProfile(),namaStatus, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}
	
	public Map<String, Object> comboStatusPegawai(String sort, String dir, String namaStatus,Integer statusPegawaiHead) {
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<Map<String,Object>> list = new ArrayList<Map<String,Object>>();
		if (CommonUtil.isNullOrEmpty(namaStatus)) {
			list = statusDao.findStatusByHead(getKdProfile(), statusPegawaiHead, pageReq);
		} else {
			list = statusDao.findStatusByHead(getKdProfile(),statusPegawaiHead,namaStatus, pageReq);
		}
		result.put("objekStatus", list);
		resultSuccessful();

		return result;
	}

	private Map<String, Object> createTree(List<Status> nodes) {

		Map<String, Status> mapTmp = new HashMap<>();

		// Save all nodes to a map
		for (Status current : nodes) {
			mapTmp.put(current.getId().getKdStatus().toString(), current);
		}

		// loop and assign parent/child relationships
		for (Status current : nodes) {
			Integer parentId = current.getKdStatusHead();

			if (parentId != null) {
				Status parent = mapTmp.get(parentId.toString());
				if (parent != null) {
					// current.setVersionHead(parent);
					parent.addChild(current);
					mapTmp.put(parentId.toString(), parent);
					mapTmp.put(current.getId().getKdStatus().toString(), current);
				}
			}
		}

		List<Status> status = new ArrayList<>();
		for (Status d : mapTmp.values()) {
			if (CommonUtil.isNullOrEmpty(d.getKdStatusHead()) || CommonUtil.isNotNullOrEmpty(d.getChildren())) {
				status.add(d);
			}

		}
		Map<String, Object> da = new HashMap<>();
		da.put("objekStatus", status);
		return da;
	}

	public Map<String, Object> findByKdStatus(Integer kdStatus, boolean isHierarki) {
		result.clear();
		List<Status> list = new ArrayList<>();
		if (isHierarki) {
			list = statusDao.findByKdStatusWithIsHierarkiTrue(getKdProfile(),kdStatus);
			result = createTree(list);
		} else {
			list = statusDao.findByKdStatusWithIsHierarkiFalse(getKdProfile(),kdStatus);
			result.put("objekStatus", list);
		}
		resultSuccessful();
		return result;

	}

	public List<Map<String, Object>> treeStatus(Integer kdStatus) {
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals("asc") ? Direction.DESC : Direction.ASC, "namaStatus");
		List<Map<String, Object>> listObjectModulAplikasiByHead = statusDao.findStatusByHead(getKdProfile(),kdStatus,pageReq);
		List<Map<String, Object>> tmpListObjectModulAplikasiByHead = new ArrayList<Map<String, Object>>();
		for (Map<String, Object> object : listObjectModulAplikasiByHead) {
			tmpListObjectModulAplikasiByHead.add(object);
		}
		return listObjectModulAplikasiByHead;

	}

}